'use strict';YUI.add('juju-controller-api',function(Y){var module=Y.juju.environments;var tags=module.tags;function ControllerAPI(config){ControllerAPI.superclass.constructor.apply(this,arguments);}ControllerAPI.NAME='controller-api';Y.extend(ControllerAPI,module.BaseEnvironment,{initializer:function initializer(){this.defaultUser='admin';this._pinger=null;this.pendingLoginResponse=false;},dispatch_result:function dispatch_result(data){var tid=data['request-id'];if(tid in this._txn_callbacks){this._txn_callbacks[tid].call(this,data);delete this._txn_callbacks[tid];}},_send_rpc:function _send_rpc(op,callback){var facade=op.type;var version=op.version;if(facade!=='Admin'){version=this.findFacadeVersion(facade,version);}if(version===null){var err='api client: operation not supported: '+JSON.stringify(op);console.error(err);if(callback){callback({error:err});}return;}if(this.ws.readyState!==1){console.log('Websocket is not open, dropping request. '+'readyState: '+this.ws.readyState,op);return;}op.version=version;var tid=this._counter+=1;if(callback){this._txn_callbacks[tid]=callback;}op['request-id']=tid;if(!op.params){op.params={};}var msg=JSON.stringify(op);this.ws.send(msg);},handleLogin:function handleLogin(data){this.pendingLoginResponse=false;this.userIsAuthenticated=!data.error;if(this.userIsAuthenticated){var response=data.response;var facadeList=response.facades||[];var facades=facadeList.reduce(function(previous,current){previous[current.name]=current.versions;return previous;},{});this.setConnectedAttr('facades',facades);var userInfo=response['user-info'];this.setConnectedAttr('controllerAccess',userInfo['controller-access']);this.setConnectedAttr('controllerId',tags.parse(tags.CONTROLLER,response['controller-tag']));if(!this._pinger){this._pinger=setInterval(this.ping.bind(this),module.PING_INTERVAL*1000);}this.failedAuthentication=false;}else{this.setCredentials(null);this.failedAuthentication=true;}this.fire('login',{err:data.error||null});},findFacadeVersion:function findFacadeVersion(name,version){var facades=this.get('facades')||{};var versions=facades[name]||[];if(!versions.length){return null;}if(version===undefined||version===null){return versions[versions.length-1];}if(versions.indexOf(version)>-1){return version;}return null;},login:function login(){if(this.userIsAuthenticated){this.fire('login',{err:null});return;}if(this.pendingLoginResponse){return;}var credentials=this.getCredentials();if(!credentials.user||!credentials.password){this.fire('login',{err:'invalid username or password'});return;}this._send_rpc({type:'Admin',request:'Login',params:{'auth-tag':tags.build(tags.USER,credentials.user),credentials:credentials.password},version:module.ADMIN_FACADE_VERSION},this.handleLogin);this.pendingLoginResponse=true;},loginWithMacaroon:function loginWithMacaroon(bakery,callback){if(this.pendingLoginResponse){return;}var cback=function(err,response){this.handleLogin({error:err,response:response});if(callback){callback(err);return;}if(err){console.warn('macaroon authentication failed:',err);return;}console.debug('macaroon authentication succeeded');}.bind(this);var handleResponse=function handleResponse(bakery,macaroons,cback,data){var _this=this;if(data.error){cback('authentication failed: '+data.error);return;}var response=data.response;var macaroon=response['discharge-required'];if(macaroon){bakery.discharge(macaroon,function(macaroons){sendLoginRequest(macaroons,handleResponse.bind(_this,bakery,macaroons,cback));},function(msg){cback('macaroon discharge failed: '+msg);});return;}var userInfo=response['user-info'];var userTag=userInfo&&userInfo.identity;if(!userTag){cback('authentication failed: use a proper Juju 2 release');return;}this.setCredentials({macaroons:macaroons,user:tags.parse(tags.USER,userTag)});cback(null,response);};var sendLoginRequest=function(macaroons,callback){var request={type:'Admin',request:'Login',version:module.ADMIN_FACADE_VERSION};if(macaroons){request.params={macaroons:[macaroons]};}this._send_rpc(request,callback);}.bind(this);var macaroons=this.getCredentials().macaroons;sendLoginRequest(macaroons,handleResponse.bind(this,bakery,macaroons,cback));this.pendingLoginResponse=true;},cleanup:function cleanup(done){console.log('cleaning up the controller API connection');if(this._pinger){clearInterval(this._pinger);this._pinger=null;}this.resetConnectedAttrs();done();},ping:function ping(){this._send_rpc({type:'Pinger',request:'Ping'});},modelInfo:function modelInfo(ids,callback){var handler=function handler(data){if(!callback){console.log('data returned by model info API call:',data);return;}if(data.error){callback(data.error,[]);return;}var results=data.response.results;if(results.length!==ids.length){callback('unexpected results: '+JSON.stringify(results),[]);return;}var models=results.map(function(result,index){var err=result.error&&result.error.message;var id=ids[index];if(err){return{id:id,err:err};}result=result.result;return{id:id,name:result.name,series:result['default-series'],provider:result['provider-type'],uuid:result.uuid,controllerUUID:result['controller-uuid'],owner:tags.parse(tags.USER,result['owner-tag']),life:result.life,isAlive:result.life==='alive',isAdmin:result.uuid===result['controller-uuid']};});callback(null,models);};var entities=ids.map(function(id){return{tag:tags.build(tags.MODEL,id)};});this._send_rpc({type:'ModelManager',request:'ModelInfo',params:{entities:entities}},handler);},listModelsWithInfo:function listModelsWithInfo(callback){var _this2=this;if(!callback){callback=function callback(err,models){console.log('listModelsWithInfo: no callback provided');if(err){console.log('listModelsWithInfo: API call error:',err);}else{console.log('listModelsWithInfo: API call results:',models);}};}var credentials=this.getCredentials();if(!credentials.user){callback('called without credentials',[]);return;}this.listModels(credentials.user,function(err,listedModels){if(err){callback(err,[]);return;}var ids=listedModels.map(function(model){return model.id;});_this2.modelInfo(ids,function(err,infoModels){if(err){callback(err,[]);return;}var models=infoModels.map(function(model,index){if(model.err){return{id:model.id,err:model.err};}return{id:model.id,name:model.name,series:model.series,provider:model.provider,uuid:model.uuid,controllerUUID:model.controllerUUID,owner:model.owner,life:model.life,isAlive:model.isAlive,isAdmin:model.isAdmin,lastConnection:listedModels[index].lastConnection};});callback(null,models);});});},createModel:function createModel(name,user,args,callback){var handler=function handler(data){if(!callback){console.log('data returned by CreateModel API call:',data);return;}if(data.error){callback(data.error,{});return;}var response=data.response;var credential='';var credentialTag=response['cloud-credential-tag'];if(credentialTag){credential=tags.parse(tags.CREDENTIAL,credentialTag);}callback(null,{name:response.name,uuid:response.uuid,owner:tags.parse(tags.USER,response['owner-tag']),provider:response['provider-type'],series:response['default-series'],cloud:tags.parse(tags.CLOUD,response['cloud-tag']),region:response['cloud-region'],credential:credential});};if(user.indexOf('@')===-1){user+='@local';}var cloudTag=void 0;if(args.cloud){cloudTag=tags.build(tags.CLOUD,args.cloud);}var credentialTag=void 0;if(args.credential){credentialTag=tags.build(tags.CREDENTIAL,args.credential);}this._send_rpc({type:'ModelManager',request:'CreateModel',params:{name:name,'owner-tag':tags.build(tags.USER,user),config:args.config||undefined,'cloud-tag':cloudTag,region:args.region||undefined,credential:credentialTag}},handler);},destroyModels:function destroyModels(ids,callback){var handler=function handler(data){if(!callback){console.log('data returned by destroy models API call:',data);return;}if(data.error){callback(data.error,{});return;}var results=data.response.results.reduce(function(prev,result,index){var id=ids[index];prev[id]=result.error?result.error.message:null;return prev;},{});callback(null,results);};var entities=ids.map(function(id){return{tag:tags.build(tags.MODEL,id)};});this._send_rpc({type:'ModelManager',request:'DestroyModels',params:{entities:entities}},handler);},listModels:function listModels(user,callback){var handleListModels=function handleListModels(data){if(!callback){console.log('data returned by ListModels API call:',data);return;}if(data.error){callback(data.error,[]);return;}var userModels=data.response['user-models'];if(!userModels||!userModels.length){callback(null,[]);return;}var models=userModels.map(function(value){var model=value.model;return{id:model.uuid,name:model.name,owner:tags.parse(tags.USER,model['owner-tag']),uuid:model.uuid,lastConnection:value['last-connection']};});callback(null,models);};this._send_rpc({type:'ModelManager',request:'ListModels',params:{tag:tags.build(tags.USER,user)}},handleListModels);},listClouds:function listClouds(callback){var _this3=this;var handler=function handler(data){if(!callback){console.log('data returned by Cloud.Clouds API call:',data);return;}if(data.error){callback(data.error,{});return;}var results=data.response.clouds||{};var clouds=Object.keys(results).reduce(function(prev,tag){var name=tags.parse(tags.CLOUD,tag);prev[name]=_this3._parseCloudResult(results[tag]);return prev;},{});callback(null,clouds);};this._send_rpc({type:'Cloud',request:'Clouds'},handler);},getClouds:function getClouds(names,callback){var _this4=this;var handler=function handler(data){if(!callback){console.log('data returned by Cloud.Cloud API call:',data);return;}if(data.error){callback(data.error,{});return;}var results=data.response.results;if(!results){callback(null,{});return;}var clouds=results.reduce(function(prev,result,index){var name=names[index];var err=result.error&&result.error.message;if(err){prev[name]={err:err};return prev;}prev[name]=_this4._parseCloudResult(result.cloud);return prev;},{});callback(null,clouds);};if(!names.length){names=[];}var entities=names.map(function(name){return{tag:tags.build(tags.CLOUD,name)};});this._send_rpc({type:'Cloud',request:'Cloud',params:{entities:entities}},handler);},getDefaultCloudName:function getDefaultCloudName(callback){var handler=function handler(data){if(!callback){console.log('data returned by Cloud.DefaultCloud API call:',data);return;}if(data.error){callback(data.error,'');return;}var response=data.response;var error=response.error&&response.error.message;if(error){callback(error,'');return;}var name=tags.parse(tags.CLOUD,response.result);callback(null,name);};this._send_rpc({type:'Cloud',request:'DefaultCloud'},handler);},_parseCloudResult:function _parseCloudResult(result){var regions=result.regions.map(function(region){return{name:region.name,endpoint:region.endpoint||'',identityEndpoint:region['identity-endpoint']||'',storageEndpoint:region['storage-endpoint']||''};});return{cloudType:result.type,authTypes:result['auth-types']||[],endpoint:result.endpoint||'',identityEndpoint:result['identity-endpoint']||'',storageEndpoint:result['storage-endpoint']||'',regions:regions};},getCloudCredentialNames:function getCloudCredentialNames(userCloudPairs,callback){var handler=function handler(data){if(!callback){console.log('data returned by Cloud.UserCredentials API call:',data);return;}if(data.error){callback(data.error,[]);return;}var results=data.response.results;if(!results){callback(null,[]);return;}var credentials=results.map(function(result){var err=result.error&&result.error.message;if(err){return{err:err};}var credentialTags=result.result||[];var names=credentialTags.map(function(credentialTag){return tags.parse(tags.CREDENTIAL,credentialTag);});return{names:names};});callback(null,credentials);};if(!userCloudPairs.length){userCloudPairs=[];}var userClouds=userCloudPairs.map(function(userCloud){return{'user-tag':tags.build(tags.USER,userCloud[0]),'cloud-tag':tags.build(tags.CLOUD,userCloud[1])};});this._send_rpc({type:'Cloud',request:'UserCredentials',params:{'user-clouds':userClouds}},handler);},getCloudCredentials:function getCloudCredentials(names,callback){var handler=function handler(data){if(!callback){console.log('data returned by Cloud.Credential API call:',data);return;}if(data.error){callback(data.error,{});return;}var results=data.response.results;if(!results){callback(null,{});return;}var credentials=results.reduce(function(prev,result,index){var name=names[index];var err=result.error&&result.error.message;if(err){prev[name]={err:err};return prev;}var entry=result.result;prev[name]={authType:entry['auth-type']||'',attrs:entry.attrs||{},redacted:entry.redacted||[]};return prev;},{});callback(null,credentials);};if(!names.length){names=[];}var entities=names.map(function(name){return{tag:tags.build(tags.CREDENTIAL,name)};});this._send_rpc({type:'Cloud',request:'Credential',params:{entities:entities}},handler);},updateCloudCredential:function updateCloudCredential(name,authType,attrs,callback){var handler=function handler(data){if(!callback){console.log('data returned by Cloud.UpdateCredentials API call:',data);return;}if(data.error){callback(data.error);return;}var results=data.response.results;if(!results||results.length!==1){callback('invalid results from Juju: '+JSON.stringify(results));return;}var err=results[0].error&&results[0].error.message;if(err){callback(err);return;}callback(null);};var credentials=[{tag:tags.build(tags.CREDENTIAL,name),credential:{'auth-type':authType||'',attrs:attrs||{}}}];this._send_rpc({type:'Cloud',request:'UpdateCredentials',params:{credentials:credentials}},handler);},revokeCloudCredential:function revokeCloudCredential(name,callback){var handler=function handler(data){if(!callback){console.log('data returned by Cloud.RevokeCredentials API call:',data);return;}if(data.error){callback(data.error);return;}var results=data.response.results;if(!results||results.length!==1){callback('invalid results from Juju: '+JSON.stringify(results));return;}var err=results[0].error&&results[0].error.message;if(err){callback(err);return;}callback(null);};this._send_rpc({type:'Cloud',request:'RevokeCredentials',params:{entities:[{tag:tags.build(tags.CREDENTIAL,name)}]}},handler);}});Y.namespace('juju').ControllerAPI=ControllerAPI;},'0.1.0',{requires:['base','juju-env-base']});